﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using GenericParsing;
using SoftArtisans.OfficeWriter.WordWriter;

namespace SalesInvoice
{
    public partial class Part1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void RunReport_Click(object sender, EventArgs e)
        {
            try
            {
                BindTemplateData();
            }
            catch (Exception ex)
            {
                ErrorLabel.Visible = true;
                //If OfficeWriter isn't installed, show this error message
                if (ex.Message.Contains("General license key exception"))
                {
                    ErrorLabel.Text = "OfficeWriter does not appear to be" +
                       " installed on this machine. If you have not " +
                       "purchased OfficeWriter, you can download the " +
                       "evaluation version here: " +
                       "http://www.officewriter.com/officewriter-free-evaluation.aspx";
                }
                else
                {
                    ErrorLabel.Text = ex.Message;
                }
            }
        }

        private void BindTemplateData()
        {
            //Instantiate a new WordTemplate object
            WordTemplate WT = new WordTemplate();

            //Open the template file
            WT.Open(Page.MapPath("//templates//Part1_Invoice_Template.docx"));

            //Create the array of header values
            object[] orderHeader = { "Jane", "Doe", DateTime.Now.ToString("MM/dd/yy") };
            //Create the array of column names
            string[] orderHeaderColNames = { "FirstName", "LastName", "Date" };

            //Create the array of details values
            object[] detailsArray = { "Sport-100 Helmet, Black", 3, 34.99, 104.97, 104.97, 4.46, 109.43 };
            //Create the array of column names
            string[] detailColNames = { "Item", "Qty", "Price", "LineTotal", "Subtotal", "Tax", "Total" };

            //Set the data sources to import data for each source
            WT.SetDataSource(orderHeader, orderHeaderColNames, "OrderHeader");
            WT.SetDataSource(detailsArray, detailColNames, "OrderDetails");

            //Process to import the data to the template
            WT.Process();

            WT.Save(Page.Response, "Part1_Output.docx", false);

        }
    }
}
